// SPDX-FileCopyrightText: 2022 Olivier Charvin
//
// SPDX-License-Identifier: EUPL-1.2+

package app

import (
	"strings"

	"code.pfad.fr/buchungssystem/internal"
	"code.pfad.fr/buchungssystem/internal/validator"
)

type BillingInfo struct {
	Kind       string
	Name       string
	Address1   string
	Address2   string
	PostalCode string
	City       string
	Country    string
}

func stringNotEmpty(s string) bool {
	return s != ""
}

func countryExists(id string) bool {
	for _, c := range billingCountries {
		if c.ID == id {
			return true
		}
	}
	return false
}

func parseBillingInfo(valueOf func(string) string) (BillingInfo, error) {
	v := validator.New(valueOf)
	return BillingInfo{
		Kind:       v.TrimmedString("kind", stringNotEmpty),
		Name:       v.TrimmedString("name", stringNotEmpty),
		Address1:   v.TrimmedString("address1", stringNotEmpty),
		Address2:   v.TrimmedString("address2"),
		PostalCode: strings.ReplaceAll(v.TrimmedString("postal_code", stringNotEmpty), " ", ""),
		City:       v.TrimmedString("city", stringNotEmpty),
		Country:    v.TrimmedString("country", countryExists),
	}, v.HTTPErr()
}

var billingKinds = internal.Options{
	{
		ID:   "dpsg",
		Name: "DPSG Stamm",
	},
	{
		ID:   "verein",
		Name: "Verein",
	},
	{
		ID:   "firma",
		Name: "Firma",
	},
	{
		ID:   "privat",
		Name: "Privat",
	},
}

// source https://www.auswaertiges-amt.de/de/service/terminologie/-/215252
var billingCountries = internal.Options{
	{Name: "Afghanistan", ID: "AFG"},
	{Name: "Ägypten", ID: "EGY"},
	{Name: "Albanien", ID: "ALB"},
	{Name: "Algerien", ID: "DZA"},
	{Name: "Andorra", ID: "AND"},
	{Name: "Angola", ID: "AGO"},
	{Name: "Antigua und Barbuda", ID: "ATG"},
	{Name: "Äquatorialguinea", ID: "GNQ"},
	{Name: "Argentinien", ID: "ARG"},
	{Name: "Armenien", ID: "ARM"},
	{Name: "Aserbaidschan", ID: "AZE"},
	{Name: "Äthiopien", ID: "ETH"},
	{Name: "Australien", ID: "AUS"},
	{Name: "Bahamas", ID: "BHS"},
	{Name: "Bahrain", ID: "BHR"},
	{Name: "Bangladesch", ID: "BGD"},
	{Name: "Barbados", ID: "BRB"},
	{Name: "Belarus", ID: "BLR"},
	{Name: "Belgien", ID: "BEL"},
	{Name: "Belize", ID: "BLZ"},
	{Name: "Benin", ID: "BEN"},
	{Name: "Bhutan", ID: "BTN"},
	{Name: "Bolivien, Plurinationaler Staat", ID: "BOL"},
	{Name: "Bosnien und Herzegowina", ID: "BIH"},
	{Name: "Botsuana", ID: "BWA"},
	{Name: "Brasilien", ID: "BRA"},
	{Name: "Brunei Darussalam", ID: "BRN"},
	{Name: "Bulgarien", ID: "BGR"},
	{Name: "Burkina Faso", ID: "BFA"},
	{Name: "Burundi", ID: "BDI"},
	{Name: "Cabo Verde", ID: "CPV"},
	{Name: "Chile", ID: "CHL"},
	{Name: "China", ID: "CHN"},
	{Name: "Cookinseln", ID: "COK"},
	{Name: "Costa Rica", ID: "CRI"},
	{Name: "Côte d'Ivoire", ID: "CIV"},
	{Name: "Dänemark", ID: "DNK"},
	{Name: "Deutschland", ID: "DEU"},
	{Name: "Dominica", ID: "DMA"},
	{Name: "Dominikanische Republik", ID: "DOM"},
	{Name: "Dschibuti", ID: "DJI"},
	{Name: "Ecuador", ID: "ECU"},
	{Name: "El Salvador", ID: "SLV"},
	{Name: "Eritrea", ID: "ERI"},
	{Name: "Estland", ID: "EST"},
	{Name: "Eswatini", ID: "SWZ"},
	{Name: "Fidschi", ID: "FJI"},
	{Name: "Finnland", ID: "FIN"},
	{Name: "Frankreich", ID: "FRA"},
	{Name: "Gabun", ID: "GAB"},
	{Name: "Gambia", ID: "GMB"},
	{Name: "Georgien", ID: "GEO"},
	{Name: "Ghana", ID: "GHA"},
	{Name: "Grenada", ID: "GRD"},
	{Name: "Griechenland", ID: "GRC"},
	{Name: "Guatemala", ID: "GTM"},
	{Name: "Guinea-Bissau", ID: "GNB"},
	{Name: "Guinea", ID: "GIN"},
	{Name: "Guyana", ID: "GUY"},
	{Name: "Haiti", ID: "HTI"},
	{Name: "Honduras", ID: "HND"},
	{Name: "Indien", ID: "IND"},
	{Name: "Indonesien", ID: "IDN"},
	{Name: "Irak", ID: "IRQ"},
	{Name: "Iran, Islamische Republik", ID: "IRN"},
	{Name: "Irland", ID: "IRL"},
	{Name: "Island", ID: "ISL"},
	{Name: "Israel", ID: "ISR"},
	{Name: "Italien", ID: "ITA"},
	{Name: "Jamaika", ID: "JAM"},
	{Name: "Japan", ID: "JPN"},
	{Name: "Jemen", ID: "YEM"},
	{Name: "Jordanien", ID: "JOR"},
	{Name: "Kambodscha", ID: "KHM"},
	{Name: "Kamerun", ID: "CMR"},
	{Name: "Kanada", ID: "CAN"},
	{Name: "Kasachstan", ID: "KAZ"},
	{Name: "Katar", ID: "QAT"},
	{Name: "Kenia", ID: "KEN"},
	{Name: "Kirgisistan", ID: "KGZ"},
	{Name: "Kiribati", ID: "KIR"},
	{Name: "Kolumbien", ID: "COL"},
	{Name: "Komoren", ID: "COM"},
	{Name: "Kongo, Demokratische Republik", ID: "COD"},
	{Name: "Kongo", ID: "COG"},
	{Name: "Korea, Demokratische Volksrepublik", ID: "PRK"},
	{Name: "Korea, Republik", ID: "KOR"},
	{Name: "Kosovo", ID: "XXK"},
	{Name: "Kroatien", ID: "HRV"},
	{Name: "Kuba", ID: "CUB"},
	{Name: "Kuwait", ID: "KWT"},
	{Name: "Laos, Demokratische Volksrepublik ", ID: "LAO"},
	{Name: "Lesotho", ID: "LSO"},
	{Name: "Lettland", ID: "LVA"},
	{Name: "Libanon", ID: "LBN"},
	{Name: "Liberia", ID: "LBR"},
	{Name: "Libyen", ID: "LBY"},
	{Name: "Liechtenstein", ID: "LIE"},
	{Name: "Litauen", ID: "LTU"},
	{Name: "Luxemburg", ID: "LUX"},
	{Name: "Madagaskar", ID: "MDG"},
	{Name: "Malawi", ID: "MWI"},
	{Name: "Malaysia", ID: "MYS"},
	{Name: "Malediven", ID: "MDV"},
	{Name: "Mali", ID: "MLI"},
	{Name: "Malta", ID: "MLT"},
	{Name: "Marokko", ID: "MAR"},
	{Name: "Marshallinseln", ID: "MHL"},
	{Name: "Mauretanien", ID: "MRT"},
	{Name: "Mauritius", ID: "MUS"},
	{Name: "Mexiko", ID: "MEX"},
	{Name: "Mikronesien, Föderierte Staaten von", ID: "FSM"},
	{Name: "Moldau, Republik", ID: "MDA"},
	{Name: "Monaco", ID: "MCO"},
	{Name: "Mongolei", ID: "MNG"},
	{Name: "Montenegro", ID: "MNE"},
	{Name: "Mosambik", ID: "MOZ"},
	{Name: "Myanmar", ID: "MMR"},
	{Name: "Namibia", ID: "NAM"},
	{Name: "Nauru", ID: "NRU"},
	{Name: "Nepal", ID: "NPL"},
	{Name: "Neuseeland", ID: "NZL"},
	{Name: "Nicaragua", ID: "NIC"},
	{Name: "Niederlande", ID: "NLD"},
	{Name: "Niger", ID: "NER"},
	{Name: "Nigeria", ID: "NGA"},
	{Name: "Niue", ID: "NIU"},
	{Name: "Nordmazedonien", ID: "MKD"},
	{Name: "Norwegen", ID: "NOR"},
	{Name: "Oman", ID: "OMN"},
	{Name: "Österreich", ID: "AUT"},
	{Name: "Pakistan", ID: "PAK"},
	{Name: "Palau", ID: "PLW"},
	{Name: "Panama", ID: "PAN"},
	{Name: "Papua-Neuguinea", ID: "PNG"},
	{Name: "Paraguay", ID: "PRY"},
	{Name: "Peru", ID: "PER"},
	{Name: "Philippinen", ID: "PHL"},
	{Name: "Polen", ID: "POL"},
	{Name: "Portugal", ID: "PRT"},
	{Name: "Ruanda", ID: "RWA"},
	{Name: "Rumänien", ID: "ROU"},
	{Name: "Russische Föderation", ID: "RUS"},
	{Name: "Salomonen", ID: "SLB"},
	{Name: "Sambia", ID: "ZMB"},
	{Name: "Samoa", ID: "WSM"},
	{Name: "San Marino", ID: "SMR"},
	{Name: "São Tomé und Príncipe", ID: "STP"},
	{Name: "Saudi-Arabien", ID: "SAU"},
	{Name: "Schweden", ID: "SWE"},
	{Name: "Schweiz", ID: "CHE"},
	{Name: "Senegal", ID: "SEN"},
	{Name: "Serbien ", ID: "SRB"},
	{Name: "Seychellen", ID: "SYC"},
	{Name: "Sierra Leone", ID: "SLE"},
	{Name: "Simbabwe", ID: "ZWE"},
	{Name: "Singapur", ID: "SGP"},
	{Name: "Slowakei", ID: "SVK"},
	{Name: "Slowenien", ID: "SVN"},
	{Name: "Somalia", ID: "SOM"},
	{Name: "Spanien", ID: "ESP"},
	{Name: "Sri Lanka", ID: "LKA"},
	{Name: "St. Kitts und Nevis", ID: "KNA"},
	{Name: "St. Lucia", ID: "LCA"},
	{Name: "St. Vincent und die Grenadinen", ID: "VCT"},
	{Name: "Südafrika", ID: "ZAF"},
	{Name: "Sudan", ID: "SDN"},
	{Name: "Südsudan", ID: "SSD"},
	{Name: "Suriname", ID: "SUR"},
	{Name: "Syrien, Arabische Republik", ID: "SYR"},
	{Name: "Tadschikistan", ID: "TJK"},
	{Name: "Tansania, Vereinigte Republik", ID: "TZA"},
	{Name: "Thailand", ID: "THA"},
	{Name: "Timor-Leste", ID: "TLS"},
	{Name: "Togo", ID: "TGO"},
	{Name: "Tonga", ID: "TON"},
	{Name: "Trinidad und Tobago", ID: "TTO"},
	{Name: "Tschad", ID: "TCD"},
	{Name: "Tschechien", ID: "CZE"},
	{Name: "Tunesien", ID: "TUN"},
	{Name: "Türkei", ID: "TUR"},
	{Name: "Turkmenistan", ID: "TKM"},
	{Name: "Tuvalu", ID: "TUV"},
	{Name: "Uganda", ID: "UGA"},
	{Name: "Ukraine", ID: "UKR"},
	{Name: "Ungarn", ID: "HUN"},
	{Name: "Uruguay", ID: "URY"},
	{Name: "Usbekistan", ID: "UZB"},
	{Name: "Vanuatu", ID: "VUT"},
	{Name: "Vatikanstadt", ID: "VAT"},
	{Name: "Venezuela, Bolivarische Republik", ID: "VEN"},
	{Name: "Vereinigte Arabische Emirate", ID: "ARE"},
	{Name: "Vereinigte Staaten", ID: "USA"},
	{Name: "Vereinigtes Königreich", ID: "GBR"},
	{Name: "Vietnam", ID: "VNM"},
	{Name: "Zentralafrikanische Republik", ID: "CAF"},
	{Name: "Zypern", ID: "CYP"},
}
